/*******************************************************************************
*
* t`qs֐AZgjNXo͑u֐
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
* $Date: 2005/11/25 10:33:12 $
* $Revision: 1.15 $
*
*
*******************************************************************************/
//#define __UART0__
//#define CLOCK_20 1 


#if defined(NC30)		/* NCxx */
	/* dummy */
#elif defined(NC77)
	#error "NC77 not supported"
#elif defined(NC79)
	#error "NC79 not supported"
#else
	#error "NC30, NC77, NC79 not defined"
#endif				/* NCxx */

#ifdef PSECTION
#pragma SECTION	program	_program_l
#endif


#define M16C

#include <stdio.h>

#ifdef MELPS7700

#ifdef __UART0__
#pragma EQU _porta  =   0x0e            /* |[gU                         */
#pragma EQU _pa_vct =   0x10            /* |[gUWX^             */
#pragma EQU _portb  =   0x0f            /* |[gV                         */
#pragma EQU _pb_vct =   0x11            /* |[gVWX^             */
#pragma EQU _mode1  =   0x30            /* t`qsOM[hWX^   */
#pragma EQU _brg1   =   0x31            /* t`qsO]xWX^       */
#pragma EQU _sbuf1  =   0x32            /* t`qsOMobt@WX^   */
#pragma EQU _cntr1_l =  0x34            /* t`qsO䃌WX^ikj     */
#pragma EQU _cntr1_h =  0x35            /* t`qsO䃌WX^igj     */
#pragma EQU _rbuf1  =   0x36            /* t`qsOMobt@WX^   */
#else /* UART1 : default */
#pragma EQU _porta  =   0x0a            /* |[gS                         */
#pragma EQU _pa_vct =   0x0c            /* |[gSWX^             */
#pragma EQU _portb  =   0x0b            /* |[gT                         */
#pragma EQU _pb_vct =   0x0d            /* |[gTWX^             */
#pragma EQU _mode1  =   0x38            /* t`qsPM[hWX^   */
#pragma EQU _brg1   =   0x39            /* t`qsP]xWX^       */
#pragma EQU _sbuf1  =   0x3a            /* t`qsPMobt@WX^   */
#pragma EQU _cntr1_l =  0x3c            /* t`qsP䃌WX^ikj     */
#pragma EQU _cntr1_h =  0x3d            /* t`qsP䃌WX^igj     */
#pragma EQU _rbuf1  =   0x3e            /* t`qsPMobt@WX^   */
#endif

#define TXEPTY  0x8                     /* MWX^tO */
#define TE      0x1                     /* MtO       */
#define TI      0x2                     /* Mobt@tO */
#define RE      0x4                     /* MtO       */
#define RI      0x8                     /* MtO       */

#define ACK     0x40
#define BUSY    0x20
#define FAULT   0x10
#define RESET   0x8
#define STROBE  0x4

#define TRUE    1

char _porta;
char _pa_vct;
char _portb;
char _pb_vct;
char _mode1;
char _brg1;
char _sbuf1;
char _cntr1_l;
char _cntr1_h;
char _rbuf1;

#ifdef CLOCK_16
#define	BRG96		51	/* f2 (16Mhz/1) / 16 /  9600 - 1 = 64	*/
#define CNTR96		0	/* f2					*/
#define	BRG48		103	/* f2 (16Mhz/1) / 16 /  4800 - 1 = 103	*/
#define CNTR48		0	/* f2					*/
#define	BRG24		25	/* f16(16Mhz/16)/ 16 /  2400 - 1 = 25	*/
#define CNTR24		1	/* f16					*/
#define	BRG12		51	/* f16(16Mhz/16)/ 16 /  1200 - 1 = 51	*/
#define CNTR12		1	/* f16					*/
#else
#define	BRG96		25	/* f2 (8Mhz/1)  / 16 /  9600 - 1 = 25	*/
#define CNTR96		0	/* f2					*/
#define	BRG48		51	/* f2 (8Mhz/1)  / 16 /  4800 - 1 = 51	*/
#define CNTR48		0	/* f2					*/
#define	BRG24		12	/* f16(8Mhz/16) / 16 /  2400 - 1 = 12	*/
#define CNTR24		1	/* f16					*/
#define	BRG12		25	/* f16(8Mhz/16) / 16 /  1200 - 1 = 25	*/
#define CNTR12		1	/* f16					*/
#endif
#endif	/* MELPS7700 */

#ifdef M16C

#ifdef	__R8C__

#ifdef __UART0__
#pragma ADDRESS _mode1		0A0H	/* UART0M[hWX^ */
#pragma ADDRESS _brg1		0A1H	/* UART0]xWX^ */
#pragma ADDRESS _sbuf1		0A2H	/* UART0Mobt@WX^ */
#pragma ADDRESS _cntr1_l	0A4H	/* UART0䃌WX^(L) */
#pragma ADDRESS _cntr1_h	0A5H	/* UART0䃌WX^(H) */
#pragma ADDRESS _rbuf1		0A6H	/* UART0Mobt@WX^ */
#else /* UART1 : default */
#pragma ADDRESS _mode1		0A8H	/* UART1M[hWX^   */
#pragma ADDRESS _brg1		0A9H	/* UART1]xWX^       */
#pragma ADDRESS _sbuf1		0AAH	/* UART1Mobt@WX^   */
#pragma ADDRESS _cntr1_l	0ACH	/* UART1䃌WX^(L)     */
#pragma ADDRESS _cntr1_h	0ADH	/* UART1䃌WX^(H)     */
#pragma ADDRESS _rbuf1		0AEH	/* UART1Mobt@WX^   */
#endif

#else // __R8C__

#ifdef __UART0__
#pragma EQU _porta  =   0x3EC           /* |[gU                         */
#pragma EQU _pa_vct =   0x3EE           /* |[gUWX^             */
#pragma EQU _portb  =   0x3ED           /* |[gV                         */
#pragma EQU _pb_vct =   0x3EF           /* |[gVWX^             */
#pragma EQU _mode1  =   0x3A0           /* t`qsOM[hWX^   */
#pragma EQU _brg1   =   0x3A1           /* t`qsO]xWX^       */
#pragma EQU _sbuf1  =   0x3A2           /* t`qsOMobt@WX^   */
#pragma EQU _cntr1_l =  0x3A4           /* t`qsO䃌WX^ikj     */
#pragma EQU _cntr1_h =  0x3A5           /* t`qsO䃌WX^igj     */
#pragma EQU _rbuf1  =   0x3A6           /* t`qsOMobt@WX^   */
#else /* UART1 : default */
#pragma EQU _porta  =   0x3E8           /* |[gS                         */
#pragma EQU _pa_vct =   0x3EA           /* |[gSWX^             */
#pragma EQU _portb  =   0x3E9           /* |[gT                         */
#pragma EQU _pb_vct =   0x3EB           /* |[gTWX^             */
#pragma EQU _mode1  =   0x3A8           /* t`qsPM[hWX^   */
#pragma EQU _brg1   =   0x3A9           /* t`qsP]xWX^       */
#pragma EQU _sbuf1  =   0x3AA           /* t`qsPMobt@WX^   */
#pragma EQU _cntr1_l =  0x3AC           /* t`qsP䃌WX^ikj     */
#pragma EQU _cntr1_h =  0x3AD           /* t`qsP䃌WX^igj     */
#pragma EQU _rbuf1  =   0x3AE           /* t`qsPMobt@WX^   */
#endif

#endif  // __R8C__

#define TXEPTY  0x8                     /* MWX^tO */
#define TE      0x1                     /* MtO       */
#define TI      0x2                     /* Mobt@tO */
#define RE      0x4                     /* MtO       */
#define RI      0x8                     /* MtO       */

#define ACK     0x40
#define BUSY    0x20
#define FAULT   0x10
#define RESET   0x8
#define STROBE  0x4

#define TRUE    1

char _porta;
char _pa_vct;
char _portb;
char _pb_vct;
char _mode1;
char _brg1;
char _sbuf1;
char _cntr1_l;
char _cntr1_h;
char _rbuf1;

#define	BRG192		31	/* f1(10Mhz/1) / 16 / 19200 - 1 = 31	*/
#define CNTR192		0	/* f1					*/
#define	BRG96		64	/* f1(10Mhz/1) / 16 /  9600 - 1 = 64	*/
#define CNTR96		0	/* f1					*/
#define	BRG48		129	/* f1(10Mhz/1) / 16 /  4800 - 1 = 129	*/
#define CNTR48		0	/* f1					*/
#define	BRG24		31	/* f8(10Mhz/8) / 16 /  2400 - 1 = 31	*/
#define CNTR24		1	/* f8					*/
#define	BRG12		64	/* f8(10Mhz/8) / 16 /  1200 - 1 = 64	*/
#define CNTR12		1	/* f8					*/

#endif	/* M16C */

/*******************************************************************************
*
* init_dev 
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    init_dev -- foCX̃[hݒ
*
* @    status = init_dev( stream, mode )
*
*           #include <stdio.h>
*           FILE *stream        Xg[̃|C^
*           int  mode;          [h
*           int  status;        ^[R[h
*
* ߂l    ɐݒłꍇAPԂBɌ肪ꍇAdneԂB
*
* @@\    w肵Xg[̃[hݒ肷B
*
*******************************************************************************/

int init_dev( stream, mode )
FILE _far *stream;
int  mode;
{
    if ( mode != _TEXT && mode != _BIN )
        return  EOF;
    stream->_mod = mode;
    return  TRUE;
}


/*******************************************************************************
*
* speed 
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
* 	    Version 3.00.00
*		t`qs,NbNIΉ
*
* ֐    speed -- t`qs̏ݒ
*
* @    status = speed( rate, bit, parity, stop );
*
*           #include <stdio.h>
*           int  rate;          {[[g
*           int  bit;           f[^
*           int  parity;        peB
*           int  stop;          Xgbvrbg
*           int  status;        ^[R[h
*
* ߂l    ɏݒłꍇAPԂBG[̏ꍇAdneԂB
*
* @@\    t`qs̃{[[gAf[^ApeC̗LAXgbvrbg
*           ݒ肷B
*
*******************************************************************************/

int speed( rate, bit, parity, stop )
int  rate;                              /* {[[g       */
int  bit;                               /* f[^         */
int  parity;                            /* peB         */
int  stop;                              /* Xgbvrbg   */
{
    int mode;                           /* [hWX^̒li[ */

    _cntr1_h = NULL;                    /* 䃌WX^ */
    switch( rate ) {                    /* {[[g̐ݒ */
	case _192:
	    _brg1 = BRG192;
            _cntr1_l = CNTR192;
            break;
        case _96:
            _brg1 = BRG96;
            _cntr1_l = CNTR96;
            break;
        case _48:
            _brg1 = BRG48;
            _cntr1_l = CNTR48;
            break;
        case _24:
            _brg1 = BRG24;
            _cntr1_l = CNTR24;
            break;
        case _12:
            _brg1 = BRG12;
            _cntr1_l = CNTR12;
            break;
        default:
            return EOF;
    }
    switch( bit ) {                     /* f[^̐ݒ */
        case _B8:
            mode = 0x5;
            break;
        case _B7:
            mode = 0x4;
            break;
        default:
            return EOF;
    }
    switch( parity ) {                  /* peB̎w */
        case _PN:
            break;
        case _PE:
            mode |= 0x60;
            break;
        case _PO:
            mode |= 0x40;
            break;
        default:
            return EOF;
    }
    switch( stop ) {                    /* Xgbvrbg̐ݒ */
        case _S1:
            break;
        case _S2:
            mode |= 0x10;
            break;
        default:
            return EOF;
    }
    _mode1 = mode;
    return  TRUE;
}

/*******************************************************************************
*
* _sget 
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    _sget -- t`qŝP
*
* @    data = _sget( void );
*
*           int  data;      ͕
*
* ߂l    ɓ͂łꍇA͂ԂBG[̏ꍇAdne
*           ԂB
*
* @@\    t`qsP͂B
*
*******************************************************************************/


int _sget( )                            /* t`qsP͂ */
{
    int  data;

    _cntr1_h = _cntr1_h | RE;           /* MtOZbg */
#ifndef SIMULATOR
    while ( !( _cntr1_h & RI ) ) ;      /* MtOZbg܂ŃEGCg */
#endif
    data = _rbuf1;
    return data;
}


/*******************************************************************************
*
* _sput 
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    _sput -- t`qŝPo
*
* @    status = _sput( c );
*
*           int  c;         o͂镶
*           int  status;    ^[R[h
*
* ߂l    ɏo͂łꍇAPԂBG[̏ꍇAdneԂB
*
* @@\    t`qsPo͂B
*
*******************************************************************************/


int _sput( c )                          /* t`qsPo͂ */
int c;
{
    int i;

    _cntr1_h = _cntr1_h | TE;           /* MtOZbg */
#ifndef SIMULATOR
    while ( !( _cntr1_h & TI ) ) ;      /* Mobt@tOZbg܂ŃEGCg */
#endif
    _sbuf1 = c;
    if ( _cntr1_h & 0xf0 )
        return EOF;                     /* G[̏ꍇ */
    return  TRUE;
}


/*******************************************************************************
*
* _pput 
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    _pput -- ZgjNXo͑ûPo
*
* @    status = _pput( c );
*
*           int  c;         o͂镶
*           int  status;    ^[R[h
*
* ߂l    ɏo͂łꍇAPԂBG[̏ꍇAdneԂB
*
* @@\    ZgjNXo͑uPo͂B
*
*******************************************************************************/

int _pput( c )                          /* ZgjNXo͑uPo͂ */
int c;
{
    int  i;

    if ( _porta & FAULT )
        return EOF;
    while ( !( _porta & BUSY ) ) ;      /* BUSYM܂ŃEGCg */
    _portb = c;
    for ( i = 0 ; i < 10 ; i++ ) ;      /* EGCg */
    _porta = RESET;                     /* STROBEZbg */
    for ( i = 0 ; i < 10 ; i++ ) ;      /* EGCg */
    _porta = RESET | STROBE;            /* STROBE */
    while ( _porta & ACK ) ;            /* ACK҂ */
    if ( _porta & FAULT )
        return EOF;
    else
        return TRUE;
}



/*******************************************************************************
*
* t`qs֐AZgjNXo͑u֐
*
* Copyright(C) 1999(2000-2004). Renesas Technology Corp.
* and Renesas Solutions Corp., All rights reserved.
*
*
*******************************************************************************/
